:-module(prim_dynamic,[prim_assertFact/2,prim_retractFact/2,prim_getDynamicKnowledge/1,prim_abortTransaction/1,prim_commitTransaction/2,prim_startTransaction/1,prim_isKnownAtTime/3,abortTransaction/0,initializeDynamic/0]).
:-style_check(-singleton).
:-current_module(prologbasics)->true;use_module('../prologbasics').
:-current_module(basics)->true;use_module('../basics').
:-current_module(version)->true;use_module('../version').
:-current_module(pakcsversion)->true;use_module('../pakcsversion').
:-swi7orHigher->set_prolog_flag(double_quotes,codes);true.
:-dynamic dynamicTime/1,dynamicVersion/3,insideTransaction/0.
dynamicTime(1).
setDynamicVersion(_3186,_3180/_3182,_3190):-(retract(dynamicVersion(_3186,_3180/_3182,_3204))->true;true),asserta(dynamicVersion(_3186,_3180/_3182,_3190)).
prim_assertFact('Dynamic.Dynamic'(_3298),'Prelude.()'):-retract(dynamicTime(_3308)),_3322 is _3308+1,assertz(dynamicTime(_3322)),_3298=..[_3336,_3342,_3348,_3354|_3356],_3384=..[_3336,_3322,0|_3356],assertz(user:_3384),logDynamicEvent(_3342,assertz,_3384).
prim_retractFact('Dynamic.Dynamic'(_3486),_3492):-_3486=..[_3496,_3502,_3508,_3514|_3516],_3544=..[_3496,_3532,_3538|_3516],reloadNewestDynamicVersionOf(_3496),retract(dynamicTime(_3554)),_3568 is _3554+1,assertz(dynamicTime(_3568)),call(user:_3544),isInTimeInterval(_3554,_3532,_3538),!,_3618=..[_3496,_3532,_3554|_3516],retract(user:_3544),!,logDynamicEvent(_3502,retract,_3544),assertz(user:_3618),_3492='Prelude.True'.
prim_retractFact(_3784,'Prelude.False').
prim_getDynamicKnowledge(_3820):-reloadNewestDynamicVersions,dynamicTime(_3824),term2partcall('Dynamic.isKnownAtTime'(_3824),1,_3820),(compileWithSharing(function)->makeShare(_3820,_3846);_3846=_3820).
prim_isKnownAtTime(_3924,'Dynamic.Dynamic'(_3920),'Prelude.True'):-_3920=..[_3932,_3938,_3944,_3950|_3952],_3980=..[_3932,_3968,_3974|_3952],call(user:_3980),isInTimeInterval(_3924,_3968,_3974).
isInTimeInterval(_4072,_4074,_4076):-_4072>=_4074,(_4076=0->true;_4072=<_4076).
logDynamicEvent('Dynamic.Temporary',_4168,_4170):-!.
logDynamicEvent('Dynamic.Persistent',_4226,_4228):-_4228=..[_4232,_4238,_4244|_4246],_4274=..[_4232,0,0|_4246],_4292=..[_4226,_4274],user:dynamicPredInfo(_4232/_4300,_4306),logDynamic(_4292,_4306).
logDynamic(_4396,_4398):-dir2tmplockfile(_4398,_4404),lockWithFileIfNotInTransaction(_4404),executeWithFinalize((dir2logfile(_4398,_4414),open(_4414,append,_4422),writeq(_4422,_4396),put_code(_4422,46),nl(_4422),flush_output(_4422),close(_4422),addChangePid(_4398)),unlockWithFileIfNotInTransaction(_4404)).
executeWithFinalize(_4560,_4562):-on_exception(_4570,_4560,(call(_4562),printError(_4570),!,fail)),!,call(_4562).
executeWithFinalize(_4658,_4660):-call(_4660),!,fail.
prim_startTransaction(_4722):-(insideTransaction->writeErr('ERROR: nested transactions not supported!'),nlErr,!,fail;true),assert(insideTransaction),on_exception(_4784,initTransaction(_4722),(unlockAllPersistentDynamics,(retract(insideTransation)->true;true),printError(_4784),fail)),!.
initTransaction(_4866):-lockAllPersistentDynamics,reloadNewestDynamicVersions,retract(dynamicTime(_4870)),_4866 is _4870+1,assertz(dynamicTime(_4866)),logAllDynamicPreds(startTransaction(_4866)).
prim_commitTransaction(_4970,'Prelude.()'):-logAllDynamicPreds(commitTransaction(_4970)),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true).
prim_abortTransaction(_5054):-logAllDynamicPreds(abortTransaction),getDynamicDirs(_5062),map1partialM(prim_dynamic:addChangePid(0),_5062),unlockAllPersistentDynamics,(retract(insideTransaction)->true;true),!,fail.
getDynamicDirs(_5168):-findall(_5172,isDynamicDir(_5172),_5180),sort(_5180,_5168).
isDynamicDir(_5230):-user:dynamicPredInfo(_5234,_5230),\+_5230=''.
logAllDynamicPreds(_5296):-getDynamicDirs(_5300),map1partialM(prim_dynamic:logDynamic(_5296),_5300).
initializeDynamic:-user:dynamicPredInfo(_5360/_5362,_5368),initializeDynamic(_5368,_5360/_5362),fail.
initializeDynamic.
initializeDynamic('',_5438/_5440):-!,retractAllFacts(_5438/_5440).
initializeDynamic(_5514,_5508/_5510):-existsDirectory(_5514),!,checkDynSpec(_5514,_5508/_5510),setDynamicVersion(_5514,_5508/_5510,0),!.
initializeDynamic(_5616,_5618):-existsFile(_5616),!,appendAtom('ERROR: Directory "',_5616,_5630),appendAtom(_5630,'" for dynamic entries cannot be created!',_5638),writeErr(_5638),nlErr,!,fail.
initializeDynamic(_5736,_5730/_5732):-upDirectory(_5736,_5744),(existsDirectory(_5744)->createDynamicDir(_5736,_5730/_5732),setDynamicVersion(_5736,_5730/_5732,1);writeErr('>>> Warning: persistent dynamic data directory '),writeErr(_5736),writeErr(' not accessible!'),nlErr).
upDirectory('.',..):-!.
upDirectory(_5922,_5924):-atom_codes(_5922,_5930),append(_5940,[47|_5936],_5930),\+member(47,_5936),!,atom_codes(_5924,_5940).
upDirectory(_6030,'.').
checkDynSpec(_6072,_6066/_6068):-dir2specfile(_6072,_6080),existsFile(_6080),readPrologTermFile(_6080,_6090),dynamicSpec(_6066/_6068,_6090),!.
checkDynSpec(_6172,_6174):-appendAtom('ERROR: Directory "',_6172,_6182),appendAtom(_6182,'" contains no matching dynamic entries!',_6190),writeErr(_6190),nlErr,!,fail.
replayLogFile(_6276,_6270/_6272):-dir2tmplockfile(_6276,_6284),lockWithFileIfNotInTransaction(_6284),executeWithFinalize(replayLogFileWhenAlreadyLocked(_6276,_6270/_6272),unlockWithFileIfNotInTransaction(_6284)).
:-dynamic replayStatus/1.
replayLogFileWhenAlreadyLocked(_6392,_6386/_6388):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Restoring persistent dynamic data in directory \''),writeErr(_6392),writeErr('\'...'),nlErr;true),getRunTime(_6446),ensurePakcsVersion(_6392),dir2dbfile(_6392,_6456),dir2pofile(_6392,_6462),consultPrologorPOFile(_6456,_6462),dir2logfile(_6392,_6474),open(_6474,read,_6482),(atEndOfStream(_6482)->close(_6482);assert(replayStatus(unchanged)),repeat,on_exception(_6512,readAndReplay(_6482),((printError(_6512)->true;true),writeErr('ERROR during reading of '),writeErr(_6474),writeErr(' (restored state might be incomplete)'),nlErr)),close(_6482),retract(replayStatus(_6576)),writeNewDatabaseIfChanged(_6386/_6388,_6392,_6576)),updateDynFactsIfNecessary(_6392,_6386/_6388),readDynamicVersion(_6392,_6648),setDynamicVersion(_6392,_6386/_6388,_6648),writeChangePids(_6392,[]),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...restored in '),getRunTime(_6682),_6692 is _6682-_6446,writeErr(_6692),writeErr(' msec'),nlErr;true),!.
ensurePakcsVersion(_6874):-readPAKCSVersion(_6874,_6880),_6880=pakcsVersion(_6884,_6886),prologMajor(_6896),\+_6896=_6886,dir2pofile(_6874,_6912),(existsFile(_6912)->deleteFile(_6912);true),writePAKCSVersion(_6874),!.
ensurePakcsVersion(_7016).
isCurrentPakcsVersion(_7042):-readPAKCSVersion(_7042,_7048),compilerVersion(_7052),!,(_7048=compilerVersion(_7052)->writePAKCSVersion(_7042);_7048=pakcsVersion(_7052,_7078)).
readPAKCSVersion(_7146,_7148):-dir2pakcsversionfile(_7146,_7154),existsFile(_7154),readPrologTermFile(_7154,_7148).
writePAKCSVersion(_7222):-dir2pakcsversionfile(_7222,_7228),compilerVersion(_7232),prologMajor(_7236),writePrologTermFile(_7228,pakcsVersion(_7232,_7236)).
updateDynFactsIfNecessary(_7304,_7306):-isCurrentPakcsVersion(_7304),!.
updateDynFactsIfNecessary(_7368,_7362/_7364):-compilerVersion(_7374),(pakcsrc(dynamicmessages,yes)->writeErr('>>> Updating persistent dynamic data in directory \''),writeErr(_7368),writeErr('\' to compiler version '),writeErr(_7374),writeErr(...),nlErr;true),updateDynFacts(_7362/_7364),writeNewDatabaseIfChanged(_7362/_7364,_7368,changed),writePAKCSVersion(_7368).
updateDynFactsIfNecessary(_7540,_7542).
updateDynFacts(_7576/_7578):-functor(_7586,_7576,_7578),functor(_7594,_7576,_7578),retract(user:_7586),arg(1,_7586,_7616),arg(1,_7594,_7616),arg(2,_7586,_7632),arg(2,_7594,_7632),translateDynFactArgs(3,_7578,_7586,_7594),asserta(user:_7594),fail.
updateDynFacts(_7752).
translateDynFactArgs(_7778,_7780,_7782,_7784):-_7778>_7780,!.
translateDynFactArgs(_7858,_7860,_7862,_7864):-arg(_7858,_7862,_7872),translateDynFactArg(_7872,_7878),arg(_7858,_7864,_7878),_7896 is _7858+1,translateDynFactArgs(_7896,_7860,_7862,_7864).
translateDynFactArg(_7994,_7994):-var(_7994),!.
translateDynFactArg(_8052,_8052):-number(_8052),!.
translateDynFactArg('True','Prelude.True'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('False','Prelude.False'):-!.
translateDynFactArg('Left','Prelude.Left'):-!.
translateDynFactArg('Right','Prelude.Right'):-!.
translateDynFactArg('Nothing','Prelude.Nothing'):-!.
translateDynFactArg('Just','Prelude.Just'):-!.
translateDynFactArg('LT','Prelude.LT'):-!.
translateDynFactArg('GT','Prelude.GT'):-!.
translateDynFactArg('EQ','Prelude.EQ'):-!.
translateDynFactArg(_8590,_8592):-atomic(_8590),atom_codes(_8590,[40|_8602]),!,append("Prelude.(",_8602,_8626),atom_codes(_8592,_8626).
translateDynFactArg(_8702,_8704):-atom(_8702),atom_codes(_8702,[39|_8714]),!,(_8714=[_8724]->char_int(_8704,_8724);_8714=[78,85,76]->char_int(_8704,0);writeErr('INTERNAL ERROR in translateDynFactArg: unkown char'),nlErr).
translateDynFactArg(_8866,_8866):-atomic(_8866),!.
translateDynFactArg(_8924,_8926):-functor(_8924,_8932,_8934),translateDynFactArg(_8932,_8940),functor(_8926,_8940,_8934),translateDynFactArgs(1,_8934,_8924,_8926).
writeNewDatabaseIfChanged(_9022/_9024,_9030,changed):-!,dir2dbfile(_9030,_9038),dir2pofile(_9030,_9044),dir2logfile(_9030,_9050),appendAtom(_9038,'.bak',_9058),tell(_9058),writeq((:-dynamic _9022/_9024)),put_code(46),nl,listing(user:_9022/_9024),told,try_save_predicates(_9022/_9024,_9044),renameFile(_9058,_9038),appendAtom(_9050,'.bak',_9126),renameFile(_9050,_9126),appendAtom('touch ',_9050,_9140),shellCmd(_9140),readDynamicVersion(_9030,_9150),_9160 is _9150+1,writeDynamicVersion(_9030,_9160),(pakcsrc(dynamicmessages,yes)->writeErr('>>> ...new database constructed by merging old database and log file '),nlErr;true).
writeNewDatabaseIfChanged(_9370/_9372,_9378,_9380):-dir2logfile(_9378,_9386),appendAtom(_9386,'.bak',_9394),renameFile(_9386,_9394),appendAtom('touch ',_9386,_9408),shellCmd(_9408).
readAndReplay(_9490):-atEndOfStream(_9490),!.
readAndReplay(_9538):-read(_9538,_9544),replayEvent(_9538,_9544).
replayEvent(_9594,end_of_file):-!.
replayEvent(_9646,startTransaction(_9642)):-readAndReplayTransaction(_9646,_9642,[]),!,fail.
replayEvent(_9714,_9716):-retract(replayStatus(_9720)),assert(replayStatus(changed)),call(user:_9716),!,fail.
readAndReplayTransaction(_9812,_9814,_9816):-atEndOfStream(_9812),!,(pakcsrc(dynamicmessages,yes)->writeErr('>>> Warning: ignoring incomplete transaction '),writeErr(_9814),nlErr;true).
readAndReplayTransaction(_9924,_9926,_9928):-read(_9924,_9934),(_9934=commitTransaction(_9926)->callRevList(_9928);_9934=abortTransaction->true;readAndReplayTransaction(_9924,_9926,[_9934|_9928])),!.
callRevList([]).
callRevList([_10084|_10086]):-callRevList(_10086),retract(replayStatus(_10098)),assert(replayStatus(changed)),call(user:_10084).
startTransaction(_10176).
commitTransaction(_10202).
abortTransaction.
lockAllPersistentDynamics:-getDynamicDirs(_10240),map1M(prim_dynamic:lockDynamicDir,_10240).
lockDynamicDir(_10286):-dir2lockfile(_10286,_10292),lockWithFile(_10292).
lockWithFileIfNotInTransaction(_10340):-insideTransaction->true;lockWithFile(_10340).
lockWithFile(_10394):-appendAtom('lockfile-create --lock-name ',_10394,_10402),(existsFile(_10394),pakcsrc(dynamicmessages,yes)->writeErr('>>> Waiting for removing lock file \''),writeErr(_10394),writeErr('\'...'),nlErr;true),shellCmd(_10402),!.
unlockAllPersistentDynamics:-getDynamicDirs(_10520),map1M(prim_dynamic:unlockDynamicDir,_10520).
unlockDynamicDir(_10566):-dir2lockfile(_10566,_10572),unlockWithFile(_10572).
unlockWithFileIfNotInTransaction(_10620):-insideTransaction->true;unlockWithFile(_10620).
unlockWithFile(_10674):-existsFile(_10674),!,appendAtom('lockfile-remove --lock-name ',_10674,_10686),shellCmd(_10686).
unlockWithFile(_10746).
reloadNewestDynamicVersions:-user:dynamicPredInfo(_10772/_10774,_10780),dynamicVersion(_10780,_10772/_10774,_10800),reloadNewestDynamicVersion(_10780,_10772/_10774,_10800),fail.
reloadNewestDynamicVersions.
reloadNewestDynamicVersionOf(_10872):-dynamicVersion(_10882,_10872/_10878,_10886),!,reloadNewestDynamicVersion(_10882,_10872/_10878,_10886).
reloadNewestDynamicVersionOf(_10950).
reloadNewestDynamicVersion(_10982,_10976/_10978,0):-!,retractAllFacts(_10976/_10978),replayLogFile(_10982,_10976/_10978),!.
reloadNewestDynamicVersion(_11086,_11080/_11082,_11090):-readDynamicVersion(_11086,_11096),\+_11090=_11096,!,retractAllFacts(_11080/_11082),replayLogFile(_11086,_11080/_11082),!.
reloadNewestDynamicVersion(_11212,_11214,_11216):-readChangePids(_11212,_11222),currentPID(_11226),(_11222=[];_11222=[_11226]),!.
reloadNewestDynamicVersion(_11328,_11322/_11324,_11332):-retractAllFacts(_11322/_11324),replayLogFile(_11328,_11322/_11324).
createDynamicDir(_11420,_11414/_11416):-(pakcsrc(dynamicmessages,yes)->writeErr('>>> Creating new persistent dynamic data in directory \''),writeErr(_11420),writeErr('\'...'),nlErr;true),appendAtom('mkdir -p ',_11420,_11478),shellCmd(_11478),dir2logfile(_11420,_11488),appendAtom('touch ',_11488,_11496),shellCmd(_11496),dir2dbfile(_11420,_11506),appendAtom('touch ',_11506,_11514),shellCmd(_11514),dir2specfile(_11420,_11524),dynamicSpec(_11414/_11416,_11536),writePrologTermFile(_11524,_11536),writePAKCSVersion(_11420).
readPrologTermFile(_11664,_11666):-open(_11664,read,_11674),read(_11674,_11666),close(_11674).
writePrologTermFile(_11742,_11744):-open(_11742,write,_11752),writeq(_11752,_11744),put_code(_11752,46),nl(_11752),flush_output(_11752),close(_11752).
readDynamicVersion(_11852,_11854):-dir2versionfile(_11852,_11860),existsFile(_11860),!,on_exception(_11880,readPrologTermFile(_11860,_11854),_11854=0).
readDynamicVersion(_11948,1).
writeDynamicVersion(_11984,_11986):-dir2versionfile(_11984,_11992),writePrologTermFile(_11992,_11986).
readChangePids(_12050,_12052):-dir2changepidsfile(_12050,_12058),existsFile(_12058),!,on_exception(_12084,readPrologTermFile(_12058,_12052),_12052=[0]).
readChangePids(_12152,[]).
writeChangePids(_12188,_12190):-dir2changepidsfile(_12188,_12196),writePrologTermFile(_12196,_12190).
addChangePid(_12254):-currentPID(_12258),addChangePid(_12258,_12254).
addChangePid(_12308,_12310):-readChangePids(_12310,_12316),(member(_12308,_12316)->true;writeChangePids(_12310,[_12308|_12316])),!.
dynamicSpec(_12404/_12406,dynamicPredicate(_12404,_12406)).
retractDeadDynamicFacts(_12452/_12454):-length(_12462,_12454),_12474=..[_12452|_12462],_12462=[_12480,_12486|_12488],dynamicTime(_12498),call(user:_12474),_12486>0,_12498>_12486,retract(user:_12474),fail.
retractDeadDynamicFacts(_12616).
dir2logfile(_12642,_12644):-appendAtom(_12642,'/eventlog',_12644).
dir2lockfile(_12698,_12700):-appendAtom(_12698,'/LOCK',_12700).
dir2tmplockfile(_12754,_12756):-appendAtom(_12754,'/LOCK',_12756).
dir2dbfile(_12810,_12812):-appendAtom(_12810,'/database.pl',_12812).
dir2pofile(_12866,_12868):-appendAtom(_12866,'/dbpred.po',_12868).
dir2specfile(_12922,_12924):-appendAtom(_12922,'/spec',_12924).
dir2pakcsversionfile(_12978,_12980):-appendAtom(_12978,'/pakcsversion',_12980).
dir2versionfile(_13034,_13036):-appendAtom(_13034,'/version',_13036).
dir2changepidsfile(_13090,_13092):-appendAtom(_13090,'/changepids',_13092).
