%PAKCS1.14 swi7 VARIABLESHARING

:-noSingletonWarnings.
:-noRedefineWarnings.
:-noDiscontiguousWarnings.

:-importModule('Maybe').
:-importModule('Prelude').
:-importModule('RedBlackTree').


:-curryModule('Set').

%%%%%%%%%%%% function types %%%%%%%%%%%%%%%%%%%
:-multifile functiontype/6.
:-dynamic functiontype/6.
functiontype('Set.empty',empty,0,'Set.empty',nofix,'TCons'('RedBlackTree.RedBlackTree',[_2024490])).
functiontype('Set.null',null,0,'Set.null',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_2042314]),'TCons'('Prelude.Bool',[]))).
functiontype('Set.elem',elem,1,'Set.elem',nofix,'FuncType'(_2060054,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_2060054]),'TCons'('Prelude.Bool',[])))).
functiontype('Set.insert',insert,0,'Set.insert',nofix,'FuncType'(_2077974,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_2077974]),'TCons'('RedBlackTree.RedBlackTree',[_2077974])))).
functiontype('Set.delete',delete,0,'Set.delete',nofix,'FuncType'(_902024,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_902024]),'TCons'('RedBlackTree.RedBlackTree',[_902024])))).
functiontype('Set.toList',toList,0,'Set.toList',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_920190]),'TCons'([],[_920190]))).
functiontype('Set.fromList',fromList,0,'Set.fromList',nofix,'FuncType'('TCons'([],[_937900]),'TCons'('RedBlackTree.RedBlackTree',[_937900]))).
functiontype('Set.union',union,1,'Set.union',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_955892]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_955892]),'TCons'('RedBlackTree.RedBlackTree',[_955892])))).
functiontype('Set.intersect',intersect,2,'Set.intersect',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_974076]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_974076]),'TCons'('RedBlackTree.RedBlackTree',[_974076])))).
functiontype('Set.disjoint',disjoint,2,'Set.disjoint',nofix,'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_992254]),'FuncType'('TCons'('RedBlackTree.RedBlackTree',[_992254]),'TCons'('Prelude.Bool',[])))).

%%%%%%%%%%%% constructor types %%%%%%%%%%%%%%%%%%%
:-multifile constructortype/7.
:-dynamic constructortype/7.

%%%%%%%%%%%% function definitions %%%%%%%%%%%%%%%%%%%
'Set.empty'(_1034538,_1034540,_1034542):-freeze(_1034540,'blocked_Set.empty'(_1034538,_1034540,_1034542)).
'blocked_Set.empty'(_1034854,_1034860,_1034866):-hnf('RedBlackTree.empty'(partcall(2,'Prelude.==',[]),partcall(2,'Prelude.==',[]),partcall(2,'Prelude.<',[])),_1034854,_1034860,_1034866).

'Set.null'(_1036186,_1036188,_1036190):-freeze(_1036188,'blocked_Set.null'(_1036186,_1036188,_1036190)).
'blocked_Set.null'(_1036262,_1036268,_1036274):-hnf(partcall(1,'RedBlackTree.isEmpty',[]),_1036262,_1036268,_1036274).

'Set.elem'(_1036974,_1036976,_1036978,_1036980):-freeze(_1036978,'blocked_Set.elem'(_1036974,_1036976,_1036978,_1036980)).
'blocked_Set.elem'(_1037050,_1037304,_1037310,_1037316):-hnf('Prelude..'(partcall(1,'Maybe.isJust',[]),partcall(1,'RedBlackTree.lookup',[_1037050])),_1037304,_1037310,_1037316).

'Set.insert'(_1038600,_1038602,_1038604):-freeze(_1038602,'blocked_Set.insert'(_1038600,_1038602,_1038604)).
'blocked_Set.insert'(_1038676,_1038682,_1038688):-hnf(partcall(2,'RedBlackTree.update',[]),_1038676,_1038682,_1038688).

'Set.delete'(_1039466,_1039468,_1039470):-freeze(_1039468,'blocked_Set.delete'(_1039466,_1039468,_1039470)).
'blocked_Set.delete'(_1039542,_1039548,_1039554):-hnf(partcall(2,'RedBlackTree.delete',[]),_1039542,_1039548,_1039554).

'Set.toList'(_1040332,_1040334,_1040336):-freeze(_1040334,'blocked_Set.toList'(_1040332,_1040334,_1040336)).
'blocked_Set.toList'(_1040408,_1040414,_1040420):-hnf(partcall(1,'RedBlackTree.tree2list',[]),_1040408,_1040414,_1040420).

'Set.fromList'(_1041288,_1041290,_1041292):-freeze(_1041290,'blocked_Set.fromList'(_1041288,_1041290,_1041292)).
'blocked_Set.fromList'(_1041524,_1041530,_1041536):-hnf(partcall(1,'Prelude.foldr',['Set.empty','Set.insert']),_1041524,_1041530,_1041536).

'Set.union'(_1042564,_1042566,_1042568,_1042570):-freeze(_1042568,'blocked_Set.union'(_1042564,_1042566,_1042568,_1042570)).
'blocked_Set.union'(_1042640,_1042974,_1042980,_1042986):-hnf('Prelude..'(partcall(1,'Prelude.foldr',[_1042640,'Set.insert']),'Set.toList'),_1042974,_1042980,_1042986).

'Set.intersect'(_1044492,_1044494,_1044496,_1044498,_1044500):-freeze(_1044498,'blocked_Set.intersect'(_1044492,_1044494,_1044496,_1044498,_1044500)).
'blocked_Set.intersect'(_1044578,_1044596,_1045316,_1045322,_1045328):-hnf('Prelude.$'('Set.fromList','Prelude.$'(partcall(1,'Prelude.filter',[partcall(1,'Prelude.flip',[_1044596,partcall(1,'Set.elem',[])])]),'Prelude.apply'('Set.toList',_1044578))),_1045316,_1045322,_1045328).

'Set.disjoint'(_1047688,_1047690,_1047692,_1047694,_1047696):-freeze(_1047694,'blocked_Set.disjoint'(_1047688,_1047690,_1047692,_1047694,_1047696)).
'blocked_Set.disjoint'(_1047774,_1047792,_1048112,_1048118,_1048124):-hnf('Prelude.apply'('Set.null','Set.intersect'(_1047774,_1047792)),_1048112,_1048118,_1048124).

:-costCenters(['']).




%%%%% Number of shared variables: 0
